<script lang="ts">
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import type SharedActions from '@/logic/SharedActions';
import type { Label, LabelId, LabelPredicate } from '@/data';
import type { BScrollToEmitter } from '../scroll/BScrollToLabel.vue';
import LabelBehavior from '../LabelBehavior.vue';

/**
 * Scrolls the canvas to a given onset on canvas creation
 *
 * Requires ScrollToLabel to handle scroll as well as selection
 */
@Component
export default class BPrevNextOnKey extends LabelBehavior<BScrollToEmitter> {
  onArrowKeyDown(e: KeyboardEvent) {
    // Only listen to
    // shift-left, shift-right => prev label, next label
    // ctrl-left, ctrl-right => prev/next label of same type
    // ctrl-shift-left, ctrl-shift-right => prev/next label of same tag
    if (e.key !== 'ArrowRight' && e.key !== 'ArrowLeft') return;

    // Prevent the default DOM actions
    // shift-left: scroll + select
    // ctrl-left: normal scroll
    e.preventDefault();

    // Get the event info
    const label: Label | null = this.actions.getSelected();
    const labelId: LabelId | null = label?.id ?? null;
    const right = e.key === 'ArrowRight';
    const shift = e.shiftKey;
    const ctrl = e.ctrlKey;

    // If a label is selected, find the 'predicate'
    // To find the next/prev label matching the predicate
    let predicate: LabelPredicate | undefined;
    if (label && shift && ctrl) predicate = (l) => l.tag === label.tag;
    else if (label && ctrl) predicate = (l) => l.type === label.type;

    // Find the prev/next label
    const nextLabel = right
      ? this.actions.getNext(labelId, predicate)
      : this.actions.getPrev(labelId, predicate);

    // If label is found, select and scroll to it
    if (nextLabel) {
      this.actions.select(nextLabel.id);
      this.emit('scroll-to-selection');
    } else {
      this.actions.select(null);
    }
  }

  mounted() {
    // Listen to any keydown with a control modifier
    this.register('document-ctrl-keydown', this.onArrowKeyDown);
    this.register('document-ctrl-shift-keydown', this.onArrowKeyDown);
  }

  @Prop()
  actions!: SharedActions;
}
</script>
